#
# spec file for package transcode
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%ifnarch %ix86 x86_64
%define _lto_cflags %{nil}
%endif
%define subver %{nil}
%bcond_without a52
%if 0%{?suse_version} == 1500
%bcond_with imagemagick
%else
%bcond_without imagemagick
%endif
%bcond_without libdv
%bcond_without libdvdread
%bcond_without libfame
%bcond_without libjpeg
%bcond_without libquicktime
%bcond_without libxml2
%bcond_without lzo
%bcond_without mjpegtools
%bcond_without mmx
%bcond_without netstream
%bcond_without ogg
%bcond_without sdl
%bcond_without theora
%bcond_without v4l
%bcond_without vorbis
%bcond_without libpostproc
%bcond_without freetype2
%bcond_without x264
%bcond_with pvm3
%bcond_without libmpeg2
%bcond_without alsa
%bcond_without avifile
%bcond_without ibp
%bcond_without libmpeg3
%bcond_without xio
Name:           transcode
Version:        1.1.7
Release:        10.2
Summary:        A linux video stream processing utility
Summary(de):    Das Schweizer Taschenmesser der Videobearbeitung
License:        GPL-2.0+
Group:          Productivity/Multimedia/Other
Url:            https://bitbucket.org/france/transcode-tcforge/overview
Source:         %{name}-%{version}.tar.bz2
Source2:        export_dvraw.c
# Fix 64 bit portability issue in export_ffmpeg.c
Patch1:         transcode-fix-64bit-portability.patch
Patch2:         transcode.ImageMagick-API.patch
Patch3:         transcode.a52.patch
# http://article.gmane.org/gmane.comp.video.transcode.user/18434
# http://article.gmane.org/gmane.comp.video.transcode.user/18381
# http://article.gmane.org/gmane.comp.video.transcode.user/18446
# Gentoo
Patch0:         transcode-export_ffmpeg.patch
Patch10:        transcode-1.1.7-ffmpeg.patch
Patch11:        transcode-1.1.7-ffmpeg-0.10.patch
Patch12:        transcode-1.1.7-ffmpeg-0.11.patch
Patch13:        transcode-1.1.7-preset-free.patch
Patch14:        transcode-1.1.7-libav-9.patch
Patch15:        transcode-1.1.7-preset-force.patch
Patch16:        transcode-1.1.7-ffmpeg2.patch
Patch17:        transcode-1.1.7-freetype251.patch
# ALTLinux patches
Patch18:        transcode-1.1.7-libav-10.patch
Patch98:        transcode-1.1.5-textrel.patch
# From Gentoo for ffmpeg-4
Patch20:        transcode-1.1.7-ffmpeg29.patch
Patch19:        ffmpeg4.patch
Patch30:        transcode-gcc10.patch
BuildRequires:  libtool
BuildRequires:  faac-devel
BuildRequires:  glibc-devel
BuildRequires:  imake
%if %{with imagemagick}
BuildRequires:  pkgconfig(MagickWand)
%endif
BuildRequires:  alsa-devel
BuildRequires:  liba52-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libtwolame-devel
BuildRequires:  lzo-devel
BuildRequires:  mjpegtools-devel
BuildRequires:  libmpeg2-devel
BuildRequires:  libnetpbm-devel
BuildRequires:  libpng-devel
BuildRequires:  x264-devel >= 0.66
BuildRequires:  libxvidcore-devel
BuildRequires:  xorg-cf-files
BuildRequires:  pkgconfig(libavcodec) = 57.107.100
BuildRequires:  pkgconfig(libavformat) = 57.83.100
BuildRequires:  pkgconfig(libavresample) = 3.7.0
BuildRequires:  pkgconfig(libpostproc) = 54.7.100
BuildRequires:  pkgconfig(libswscale) = 4.8.100
BuildRequires:  pkgconfig(libdv)
BuildRequires:  pkgconfig(dvdread)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(libquicktime)
BuildRequires:  pkgconfig(libv4l1)
BuildRequires:  pkgconfig(libv4l2)
BuildRequires:  pkgconfig(libv4lconvert)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(sdl)
BuildRequires:  pkgconfig(theora)
BuildRequires:  pkgconfig(theoradec)
BuildRequires:  pkgconfig(theoraenc)
BuildRequires:  pkgconfig(vorbis)
BuildRequires:  pkgconfig(vorbisenc)
BuildRequires:  pkgconfig(vorbisfile)
BuildRequires:  pkgconfig(xaw6)
BuildRequires:  pkgconfig(xaw7)
BuildRequires:  pkgconfig(xpm)
BuildRequires:  pkgconfig(xv)
%if 0%{?suse_version} < 1500
BuildRequires:  gcc7
%endif

%description
transcode  is a linux text-console utility for video stream
processing.

Decoding and encoding is done by loading modules that are
responsible for feeding transcode with raw video/audio streams (import
modules) and encoding the frames (export modules).

It supports elementary video and audio frame transformations, including
de-interlacing or fast resizing of video frames and loading of external
filters.

A number of modules are included to enable import of DVDs
on-the-fly, MPEG elementary (ES) or program streams (VOB), MPEG video,
Digital Video (DV), YUV4MPEG streams, NuppelVideo file format and raw or
compressed (pass-through) video frames and export modules for writing
DivX;-), OpenDivX, DivX 4.xx or uncompressed AVI files with MPEG, AC3
(pass-through) or PCM audio. Additional export modules to write single
frames (PPM) or YUV4MPEG streams are available, as well as an interface
import module to the avifile library. It's modular concept is intended
to provide flexibility and easy user extensibility to include other
video/audio codecs or filetypes.

A set of tools is included to demux (tcdemux), extract (tcextract) and
decode (tcdecode) the sources into raw video/audio streams for import,
probing (tcprobe) and scanning (tcscan) your sources and to enable
post-processing of AVI files, fixing AVI file header information
(avifix), merging multiple files (avimerge) or splitting large AVI files
(avisplit) to fit on a CD.

%description -l de
Videokonverter mit sehr vielen input/output und filter plugins, kann auch zum
encodieren von dvd's genutzt werden.

%prep
%setup -q -n %{name}-%{version}%{subver}
#
install -m644 %{SOURCE2} filter/
%patch0
%patch10
%patch11
%patch12
%patch13
%patch14
%patch15
%patch16 -p1
%patch17 -p1
#
%patch18 -p1
%patch98 -p2
#
%patch1
%patch2 -p1
%patch3 -p1
%patch20 -p0
%patch19 -p0

%patch30 -p1

%build
test -x "$(type -p gcc)"   && export CC="$_"
test -x "$(type -p gcc-7)" && export CC="$_"
test -x "$(type -p gcc-8)" && export CC="$_"
autoreconf -fi
CFLAGS="%{optflags} -Wno-implicit-function-declaration -Werror=int-conversion"
%configure --enable-experimental \
     --enable-deprecated \
     --disable-x86-textrels \
     --enable-mmx \
     --enable-a52 \
%if %{with a52}
     --enable-a52 \
%endif
%if %{with imagemagick}
     --enable-imagemagick \
%else
     --disable-imagemagick \
%endif
     --enable-libdv \
     --enable-libdvdread \
%if 1 == 0
#%%{with libfame}
     --with-libfame-libs=%{_libexecdir} \
     --enable-libfame \
%endif
     --enable-libjpeg \
     --enable-lame \
     --enable-libquicktime \
     --enable-libxml2 \
     --enable-lzo \
     --enable-mjpegtools \
     --enable-ffmpeg \
     --enable-ogg \
     --enable-sdl \
     --enable-theora \
%if %{with v4l}
     --enable-v4l \
     --enable-libv4l2 \
     --enable-libv4lconvert \
%endif
     --enable-vorbis \
     --enable-libpostproc \
     --enable-alsa \
     --enable-xvid \
     --enable-x264 \
%ifarch %ix86 x86_64
     --enable-nuv \
%endif
%if %{with libmpeg2}
     --enable-libmpeg2 \
     --enable-libmpeg2convert \
%endif
     --enable-freetype2 \
     --enable-faac
#

make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install %{?_smp_mflags}

find %{buildroot} -type f -name "*.la" -delete -print

rm -rf %{buildroot}%{_datadir}/doc/%{name}
rm -rf %{buildroot}%{_docdir}/%{name}/man docs/man
rm -f %{buildroot}%{_bindir}/pvmgs
find docs/ -name 'Makefile*' -print -delete
rm -f docs/tcmkmodhelp.py
rm -f docs/make-filter-man.sh
rm -f docs/make-import-man.sh
find docs/ -name tcindent.sh -print -exec chmod 0644 {} \;

%files
%defattr(-,root,root)
%{_bindir}/avifix
%{_bindir}/aviindex
%{_bindir}/avimerge
%{_bindir}/avisplit
%{_bindir}/avisync
%{_bindir}/tccat
%{_bindir}/tcdecode
%{_bindir}/tcdemux
%{_bindir}/tcexport
%{_bindir}/tcextract
%{_bindir}/tcmodchain
%{_bindir}/tcmodinfo
%{_bindir}/tcmp3cut
%{_bindir}/tcprobe
%{_bindir}/tcrequant
%{_bindir}/tcscan
%{_bindir}/tcxmlcheck
%{_bindir}/tcxpm2rgb
%{_bindir}/tcyait
%{_bindir}/transcode
%{_libdir}/%{name}/
%{_mandir}/man1/*
%{_datadir}/%{name}/
%doc AUTHORS COPYING ChangeLog README TODO docs/*

%changelog
* Wed Jul  8 2020 fridrich.strba@bluewin.ch
- Added patch:
  * transcode-gcc10.patch
    + fix duplicate symbols when building with gcc 10
* Wed Sep  4 2019 olaf@aepfle.de
- Disable lto on arm
* Thu Feb 14 2019 davejplater@gmail.com
- Used ffmpeg4.patch and transcode-1.1.7-ffmpeg29.patch from gentoo
  to enable transcode to build against ffmpeg-3. Can't build
  against ffmpeg-4 due to the use of depreciated
  av_audio_resample_init( in filters/filter_resample.c
* Fri May 25 2018 davejplater@gmail.com
- Disable ImageMagick in Leap:15.0 build to work around build failure.
* Thu May  4 2017 olaf@aepfle.de
- Partly adopt to ImageMagick7 API with transcode.ImageMagick-API.patch
* Thu Jan  7 2016 davejplater@gmail.com
- Fixed 64 bit portability with transcode-fix-64bit-portability.patch
* Thu Jan  7 2016 davejplater@gmail.com
- Reverted to trancode-1.1.7 from gentoo
- Added patches:
  * transcode-export_ffmpeg.patch
  * transcode-1.1.7-ffmpeg.patch
  * transcode-1.1.7-ffmpeg-0.10.patch
  * transcode-1.1.7-ffmpeg-0.11.patch
  * transcode-1.1.7-preset-free.patch
  * transcode-1.1.7-libav-9.patch
  * transcode-1.1.7-preset-force.patch
  * transcode-1.1.7-ffmpeg2.patch
  * transcode-1.1.7-freetype251.patch
  [#] ALTLinux patches
  * transcode-1.1.7-libav-10.patch
  * transcode-1.1.5-textrel.patch
- Upstream changes:
  transcode-1.1.7
  * Update the video stabilization plugins to version 0.80.
  transcode-1.1.6
  * Fixed bugs: #16452, #16703, #16648, #16611, #16844
  * tcdemux: fixed crash when using the new -A mode.
  * x264: fix to work properly with libx264 >= 78;
  require libx264 >= 66.
  * Update the video stabilization plugins to version 0.79.
  * Better maximum size detection for avisplit.
  * EXPERIMENTAL ffmpeg encoder preset support.
  * FFMpeg 0.8.x compatibility.
  * video4linux: made the v1 and v2 modules independent.
  v1 is deprecated.
  * Backported various minor bugfixes from HEAD/default.
* Sat Dec 26 2015 davejplater@gmail.com
- Add links to versioned binaries to enable other programs ie.k3b
  to find them.
* Mon Dec 21 2015 olaf@aepfle.de
- Adjust BuildRequires to use pkg-config
- enable shout
- drop obsolete patches
* Sat Dec 19 2015 davejplater@gmail.com
- Update to transcode-1.2.0
- Upstream changes :
  [+] Brand new export layer with new-style, separate encoders and
    muxers.
  [+] New encoders: theora, vorbis, faac, x264.
  [+] New multiplexors: ogg, libavformat, yuv4mpeg2.
  [+] New filter: barrel.
  [+] ShoutCast support using ogg multiplexor.
  [!] Fix crash when using transformations (-Z, -j).
  [!] Fix compilation error with x264 version 78.
  [*] Improved internal buffering system.
  [*] Added basic A/V synchronization module.
  [!] Fix misuse of configuration files which leads to crash.
  [*] Allow to handle fallback directories for configuration files
  [*] Improved debug messages handling and internal debug API.
  [-] The import_imlist is deprecated. Use --multi_input -x im
    instead.
  [*] Big YAIT update by Allan Snider.
  [!] Make the -W option work again like 1.0.x branch.
  [*] Switch from ImageMagick to GraphicsMagick.
  [*] Allow to build without FFmpeg.
  [!] Remove outdated libav* information from the FAQ.
  [+] Added support for CubicKeys4 and Sinc8 zoom algorithms.
  [+] Added module registry to automatically select a module from
    format
  [+] Added `tccfgshow' to inspect the transcode internal
    capabilities.
  [-] Removed the unmantained PVM code.
  [+] Added a special-crafted import module targeting webcams
    using libv4l.
  [*] Update the video stabilization plugins to version 0.61.
  [*] Added the -X option to tcdecode (let the user specify the
    acceleration)
  [+] Enable versioned, parallel installation.
* Mon Aug 19 2013 guillaume@opensuse.org
- Fix ARM build
* Thu Aug  1 2013 Manfred.Tremmel@iiv.de
- included a fix from Wolfgang Bauer for problems .
* Mon Jan 23 2012 reddwarf@opensuse.org
- Add libjpeg-devel, autoconf, automake and libtool BRs to fix
  Factory build.
* Mon Jan 23 2012 reddwarf@opensuse.org
- Add missing libdv-devel BuildRequire.
* Sun Jul 31 2011 Manfred.Tremmel@iiv.de
- ffmpeg_oldabi is build without postproc, so disabled this in
  transcode.
* Tue Dec 14 2010 pascal.bleser@opensuse.org
- fix configuration lookup path
- remove .la files
* Tue Jul 13 2010 detlef@links2linux.de
- fix 11.3 BuildRequires
* Tue Feb  9 2010 Manfred.Tremmel@iiv.de
- patch to work with latest ffmpeg snapshot
* Sun Nov 22 2009 Manfred.Tremmel@iiv.de
- little patch to compile agains a52dec svn
* Sun Nov  8 2009 Manfred.Tremmel@iiv.de
- added --enable-libmpeg2convert configure option
* Thu Nov  5 2009 Manfred.Tremmel@iiv.de
- added --enable-libmpeg2 configure option
* Mon Nov  2 2009 Manfred.Tremmel@iiv.de
- update to 1.1.5
* Mon Aug 31 2009 Manfred.Tremmel@iiv.de
- update to 1.1.4
* Wed Feb 18 2009 Manfred.Tremmel@iiv.de
- added --enable-deprecated for dvdrip compatibility
* Sat Feb 14 2009 Manfred.Tremmel@iiv.de
- updated configure options, some formats where not supported in the last
  build because the options parameters differ from previous versions
* Sun Jan 18 2009 Manfred.Tremmel@iiv.de
- update to 1.1.0
* Fri Dec 26 2008 Manfred.Tremmel@iiv.de
- update to 1.0.7
* Mon Dec 15 2008 Manfred.Tremmel@iiv.de
- recompile against new mjpegtools
* Sun Nov  2 2008 Manfred.Tremmel@iiv.de
- patched configure file to reanable imagemagick support in openSUSE >= 11.0
* Tue Sep 16 2008 detlef@links2linux.de
- rebuild with new ffmpeg
- add ffmpeg.patch
* Fri Aug  8 2008 Manfred.Tremmel@iiv.de
- update to 1.0.6
* Mon Jan 28 2008 Manfred.Tremmel@iiv.de
- update to 1.0.5
- disabled xio support (doesn't compile with 1.0.5)
* Sun Jan  6 2008 Manfred.Tremmel@iiv.de
- moved bash completion script from /etc/profile.d/ to /etc/bash_completion.d/
- bash completion script is included in the traball, it's no longer necessary to
  add it as separate source entry.
* Mon Sep 17 2007 Manfred.Tremmel@iiv.de
- update to 1.0.4
* Tue Sep  4 2007 Manfred.Tremmel@iiv.de
- added a patch to fix problems with latest ffmpeg snapshot
* Tue Mar 20 2007 Manfred.Tremmel@iiv.de
- on SUSE 10.2 no correct configure file is created, added a
  fixed file in the source list and replaced the wrong.
- compiled without libmpeg3 support (removed)
- some other little cleanups
* Fri Aug 11 2006 rainer@links2linux.de
- added patch for ffmpeg; contributed by Dana Albrecht
* Mon Jan 23 2006 rainer@links2linux.de
- removed libpostproc dep; it is now included in ffmpeg
* Tue Nov 29 2005 rainer@links2linux.de
- changed requires notation
* Sat Oct 15 2005 rainer@links2linux.de
- SuSE 10.0 - without avifile
* Sun Feb 20 2005 rainer@links2linux.de
- changes for 64 bit code
* Wed Nov 17 2004 rainer@links2linux.de
- readded pvm
* Tue Nov  9 2004 rainer@links2linux.de
- disabled libmpeg3 for SuSE 9.2. Seems to make problems with mpeg2 streams
* Sun Oct 31 2004 rainer@links2linux.de
- corrected deps
- added robin hill patch
* Sat Oct 30 2004 rainer@links2linux.de
- first 0.6.13 release
* Sun Jan 11 2004 rainer@links2linux.de
- cleaned up make and make install
* Sat Jan 10 2004 rainer@links2linux.de
- audio extract patch
* Fri Jan  9 2004 rainer@links2linux.de
- added modules
- added profile.d/transcode.sh
* Tue Nov 11 2003 rainer@links2linux.de
- re-added postproc lib
* Wed Jul 30 2003 Rainer@links2linux.de
- splitted paths
- added fix filter_resample-segfault-fix-0.6.8
* Tue Jul  8 2003 Rainer@links2linux.de
- added theora support (suse 8.2 only)
- changed to make install-strip
* Thu Jun 12 2003 Rainer@links2linux.de
- added a52dec requires
* Thu Feb 20 2003 Rainer@links2linux.de
- corrected libdvdread dependency
* Tue Feb 18 2003 Rainer@links2linux.de
- changed buildrequires to mjpegtools
* Sat Feb  8 2003 Rainer@links2linux.de
- readded xvid and ffmpeg export
- added german summary and description
* Sun Feb  2 2003 Rainer@links2linux.de
- changed to libdvdread; thanx to rafael@mondoria.de
* Fri Nov 22 2002 Rainer@links2linux.de
- corrected mplayer postproc handling
- added explicit quicktime support
* Wed Nov 20 2002 Rainer@links2linux.de
- added patch for mplayer nogui
* Fri Oct 18 2002 Rainer@links2linux.de
- added lzo
* Tue Oct  1 2002 Rainer@links2linux.de
- changed version release naming
* Fri Aug 23 2002 rainer.lay@gmx.de
- corrected manpath
* Mon Jul  8 2002 rainer.lay@gmx.de
- build on base of avifile 0.7.9
* Mon Jun 10 2002 rainer.lay@gmx.de
- removed wget html docs
* Wed Apr  3 2002 rainer.lay@gmx.de
- update to pre5
- added html docs
  Wed Jul 11 00:00:00 UTC 2001 - Thomas Östreich
- update to transcode v0.3.3
- small changes suggested by VM
* Tue Jul 10 2001 moell@gmx.de
- Wrote this specfile; first build
